unit ADU4;

interface

uses
  PORTINC, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;
  Nullp: Real;
const Neg = 8.2;
      Pos = 8.2;

implementation

{$R *.DFM}

function Zaehler (Kanal: Integer): Double;
begin
  RealTime (true);
  DTR (1);
  TimeInitus;
  Case Kanal of
  1:   While(( CTS=1) and (TimeReadus < 50000)) do;
  2:   While(( DSR=1) and (TimeReadus < 50000)) do;
  3:   While(( RI=1) and (TimeReadus < 50000)) do;
  4:   While(( DCD=1) and (TimeReadus < 50000)) do;
  end;
  Zaehler := TimeReadus;
  DTR (0);
  RealTime (false);
end;

procedure Nullpunkt;
begin
  delay (500);
  Nullp := -(Zaehler(1)/ln(1-Neg/(Pos+Neg)));
  Delay (500);

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom(pchar('com2:9600,N,8,1'));
  DTR(0);
  RTS (1);
  TXD (0);
  Timer1.Enabled := false;
  Nullpunkt;
  Timer1.Enabled := true;
end;

function Spannung(Kanal:Integer):Real;
var u:Real;
begin
  U := (neg+Pos)*(1-exp(-Zaehler(Kanal)/Nullp))-Neg;
  Spannung := Round(U*100)/100;
  delay (150);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Edit1.Text := floattostr(Spannung(1)) + ' V';
  Edit2.Text := floattostr(Spannung(2)) + ' V';
  Edit3.Text := floattostr(Spannung(3)) + ' V';
  Edit4.Text := floattostr(Spannung(4)) + ' V';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer1.Enabled := false;
  Nullpunkt;
  Timer1.Enabled := true;
end;

end.
