unit NPN;

interface

uses
  PORTINC, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Nullp: Real;
const Neg = 8.2;
      Pos = 8.2;

implementation

{$R *.DFM}

function Zaehler (Kanal: Integer): Double;
begin
  RealTime (true);
  DTR (1);
  TimeInitus;
  Case Kanal of
  1:   While(( CTS=1) and (TimeReadus < 50000)) do;
  2:   While(( DSR=1) and (TimeReadus < 50000)) do;
  3:   While(( RI=1) and (TimeReadus < 50000)) do;
  4:   While(( DCD=1) and (TimeReadus < 50000)) do;
  end;
  Zaehler := TimeReadus;
  DTR (0);
  RealTime (false);
end;

procedure Nullpunkt;
begin
  delay (500);
  Nullp := -(Zaehler(1)/ln(1-Neg/(Pos+Neg)));
  Delay (500);

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom(pchar('com2:9600,N,8,1'));
  DTR(0);
  RTS (1);
  TXD (0);
  Timer1.Enabled := false;
  Nullpunkt;
  Timer1.Enabled := true;
end;

function Spannung(Kanal:Integer):Real;
var u:Real;
begin
  U := (neg+Pos)*(1-exp(-Zaehler(Kanal)/Nullp))-Neg;
  Spannung := Round(U*100)/100;
  delay (150);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var U1,U2,U3,U4,Ib,Ic,V: Real;
begin
  U1:=Spannung(1); U2:=Spannung(2);
  U3:=Spannung(3); U4:=Spannung(4);
  Ib:=(U2-U3)*10;
  Ic:=U1-U4;
  V:=Round(Ic/(Ib+0.00001)*1000);
  Ib:= round(Ib*100)/100;
  Ic:= round(Ic*100)/100;
  Label1.Caption := 'Ub='+floattostr(U1) + ' V';
  Label2.Caption := 'Uin='+floattostr(U2) + ' V';
  Label3.Caption := 'Ube='+floattostr(U3) + ' V';
  Label4.Caption := 'Uce='+floattostr(U4) + ' V';
  Label5.Caption := 'Ib='+floattostr(Ib) + ' uA';
  Label6.Caption := 'Ic='+floattostr(Ic) + ' mA';
  Label7.Caption := 'V='+floattostr(V);
end;

end.
